<!DOCTYPE html>
<html lang="es">
    <head>
        <meta charset="utf-8" />
        <meta
            name="viewport"
            content="width=device-width, initial-scale=1, shrink-to-fit=no"
            />
        <meta name="theme-color" content="#000000" />
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/css/bootstrap.min.css" integrity="sha384-GJzZqFGwb1QTTN6wy59ffF1BuGJpLSa9DkKMp0DgiMDm4iYMj70gZWKYbI706tWS" crossorigin="anonymous">
        <script src="https://code.jquery.com/jquery-3.3.1.min.js" integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=" crossorigin="anonymous">></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.6/umd/popper.min.js" integrity="sha384-wHAiFfRlMFy6i5SRaxvfOCifBUQy1xHdJ/yoi7FRNXMRBu5WHdZYu1hA6ZOblgut" crossorigin="anonymous"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.2.1/js/bootstrap.min.js" integrity="sha384-B0UglyR+jN6CkvvICOB2joaf5I4l3gm9GU6Hc1og6Ls7i6U/mkkaduKaBhlAXv9k" crossorigin="anonymous"></script>
        <title>slim 3</title>
    </head>
    <body>
        <style>
            body{
                background: #44A08D;  /* fallback for old browsers */
                background: -webkit-linear-gradient(to right, #093637, #44A08D);  /* Chrome 10-25, Safari 5.1-6 */
                background: linear-gradient(to right, #093637, #44A08D); /* W3C, IE 10+/ Edge, Firefox 16+, Chrome 26+, Opera 12+, Safari 7+ */
            }
            .lds-ripple {
                display: inline-block;
                position: relative;
                width: 64px;
                height: 64px;
            }
            .lds-ripple div {
                position: absolute;
                border: 4px solid #fff;
                opacity: 1;
                border-radius: 50%;
                animation: lds-ripple 1s cubic-bezier(0, 0.2, 0.8, 1) infinite;
            }
            .lds-ripple div:nth-child(2) {
                animation-delay: -0.5s;
            }
            @keyframes lds-ripple {
                0% {
                    top: 28px;
                    left: 28px;
                    width: 0;
                    height: 0;
                    opacity: 1;
                }
                100% {
                    top: -1px;
                    left: -1px;
                    width: 58px;
                    height: 58px;
                    opacity: 0;
                }
            }
        </style>
        <noscript>You need to enable JavaScript to run this app.</noscript>

        <div class="container">
            <div class="row centered">
                <div class="col-8 mx-auto text-center">
                    <a href="/">
                        <img class="img-responsive text-center img-fluid" src="/images/logo.png">
                    </a>
                </div>
            </div>
            <div class="notesBoby">
                <div class="notesHeader">
                    <h5 class="text-white">Pruebas con Slim 3 y Mongodb con socket</h5>
                </div>
                <div class="notesBoby">
                    <div class="notesBoby">
                        <div class="row">
                            <div class="col-sm-4">
                                <form class="text-center border border-light p-2" name="nota">
                                    <div class="form-group">
                                        <input type="text"class="form-control" name="notaContent" id="notaContent" aria-describedby="emailHelp" placeholder="Ingresa un mensaje" />
                                    </div>
                                    <div class="form-group">
                                        <input type="text" class="form-control" name="notaUser" id="notaUser" aria-describedby="emailHelp" placeholder="Ingresa tu nombre" />
                                    </div>
                                    <button type="submit"  onClick="mongoApi.agregarNota(event)" class="btn btn-primary">Guardar</button>
                                </form>
                            </div>
                            <div class="col-sm-8">
                                <div id='listadodenotas'>
                                    <div class="lds-ripple centered"><div></div><div></div></div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <script>

                    var service = new WebSocket("ws://192.168.85.193:83");

                    window.onload = function () {
                        service.onmessage = function (event) {
                            mongoApi.obtenerLista();
                        }
                        service.onopen = function () {
                            service.send("hello!");
                        }
                        service.onclose = function () {
                            console.log("closed");
                        }
                        service.onerror = function () {
                            console.log("error");
                        }
                    }

                    function emitirMensaje() {
                        service.send("loky");
                    }

                    var mongoApi = {
                        url: '/apis/notas',
                        xhr: new XMLHttpRequest(),
                        ultimoHash: "",

                        obtenerLista: function () {
                            var _this = this;

                            $.get(this.url + '/?nocache=' + (new Date).getTime(), function (data, status) {
                                var notas = [];
                                data.list.forEach(nota => {
                                    var {notaContent, notaUser, _id} = nota;
                                    notas.unshift({
                                        key: _id.$oid,
                                        notaId: _id.$oid,
                                        notaContent: notaContent,
                                        notaUser: notaUser
                                    })
                                });
                                notas.reverse();
                                _this.generarListado(notas, data.hash);
                            });


                            _this.xhr.open('GET', (this.url + '/?nocache=' + (new Date).getTime()), true);
                            _this.xhr.setRequestHeader('Cache-Control', 'no-cache');
                            _this.xhr.onload = function () {
                                var data = JSON.parse(this.response);
                                if (_this.xhr.status >= 200 && _this.xhr.status < 400) {

                                } else {
                                    console.log('No data api');
                                }
                            }
                            _this.xhr.send();
                        },
                        generarListado: function (notas, hash) {
                            var hashActual = hash;
                            if (this.ultimoHash != hashActual) {
                                var allOrdersHtml = "";
                                notas.map((nota, key) => {
                                    var individialOrderHtml = `<div class="card text-center mt-4">
                                 <div class="card-header">
                                 usuario: ` + nota.notaUser + `
                                 </div>
                                 <div class="card-body">
                                 <h5 class="card-title">` + nota.notaContent + `</h5>
                                 <button type="button" onclick="mongoApi.eliminarNota('${nota.key}')" class="btn btn-primary">Eliminar</button>
                                 </div>
                                 </div>
                                 `;
                                    allOrdersHtml += individialOrderHtml;
                                });
                                $('#listadodenotas').html(allOrdersHtml);
                            }
                            this.ultimoHash = hashActual;
                        },
                        agregarNota: function (event) {
                            event.preventDefault();
                            if ($('#notaContent').val() && $('#notaUser').val()) {
                                $('#notaUser').prop("disabled", true);
                                var formData = new FormData();
                                formData.append("notaContent", $('#notaContent').val());
                                formData.append("notaUser", $('#notaUser').val());
                                $('#notaContent').val("");
                                $('#notaContent').focus();
                                var _this = this;
                                _this.xhr.open("POST", (this.url + '/putData'), true);
                                _this.xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest');
                                _this.xhr.onload = function () {
                                    var data = JSON.parse(this.response);
                                    if (_this.xhr.status >= 200 && _this.xhr.status < 400) {
                                        //_this.obtenerLista();
                                        emitirMensaje();
                                    } else {
                                        console.log('No data api');
                                    }
                                };
                                _this.xhr.send(formData);
                            }
                        },
                        eliminarNota: function (notaId) {
                            var _this = this;
                            _this.xhr.open("DELETE", (this.url + '/deleteData'), true);
                            _this.xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                            _this.xhr.onload = function () {
                                var data = JSON.parse(this.response);
                                if (_this.xhr.status >= 200 && _this.xhr.status < 400) {
                                    //_this.obtenerLista();
                                    emitirMensaje();
                                } else {
                                    console.log('No data api');
                                }
                            };
                            _this.xhr.send("notaId=" + notaId);
                        }
                    }
                    mongoApi.obtenerLista();
                </script>
            </div>
        </div>
        <footer class="page-footer font-small blue">

            <!-- Copyright -->
            <div class="footer-copyright text-center py-3">© 2019 Copyright:
                Arturo Tuesta
            </div>
            <!-- Copyright -->

        </footer>
    </body>
</html>
